*
*	RESOLUTION HANDLING ROUTINES
*
LINEA_I		equ	$A000 
GET_REZ		equ	4		; extended bios resolution inquiry
*
*	Get current resolution of screen: 0 => color
*		25, 40, or 50 lines
*
	.text
	.globl _getres

_getres:
	link	R14,#-4

	move.w	#GET_REZ,-(sp)		; get screen resolution
	trap	#14 
	addq.w	#2,sp
 
	cmp.w	#2,d0			; only execute if already in hi rez
	bne	exgetrf 

	move	#0,R0			; clear r0

	dc.w	LINEA_I			; get the important pointers 

	move.w	-$2A(a0),R0		; move word size to r0
	addi	#1,R0			; bump to number
	bra	exgetr			; and exit

exgetrf:
	move	#0,R0			; fasle - color monitor
exgetr:
	unlk R14
	rts
	.data
*
*
*  Make hi rez screen bios handle 25 lines of 8x16 characters
*
	.text
	.globl _rez25

_rez25: 
	link	R14,#-4			; set up

	move.w	#GET_REZ,-(sp)		; get screen resolution
	trap	#14 
	addq.w	#2,sp
 
	cmp.w	#2,d0			; only execute if already in hi rez
	bne	ex25f 
 
	dc.w	LINEA_I			; get the important pointers 
 
	move.l	08(a1),a1		; a1 -> 8x16 font header 
	move.l	72(a1),-$0A(a0)		; v_off_ad <- 8x16 offset table ad
	move.l	76(a1),-$16(a0)		; v_fnt_ad <- 8x16 font data addr 

	move.w	#0016,-$2E(a0)		; v_cel_ht <- 16  8x16 cell heigh
	move.w	#0024,-$2A(a0)		; v_cel_my <- 24  maximum cell "Y" 
	move.w	#1280,-$28(a0)		; v_cel_wr <- 1280  vertical byte offset

	move	#1,R0			; true return
	bra	ex25
ex25f:
	move	#0,R0			; false return
ex25:	unlk	R14			; prepare for return
	rts

*
*  Make hi rez screen bios handle 40 lines of 8x8 characters
*
		.globl _rez40

_rez40: 
	link	R14,#-4			; set up

	move.w	#GET_REZ,-(sp)		; get screen resolution
	trap	#14 
	addq.w	#2,sp
 
	cmp.w	#2,d0			; only execute if already in hi rez
	bne	ex40f 
 
	dc.w	LINEA_I			; get the important pointers 
 
	move.l	04(a1),a1		; a1 -> 8x8 font header 

	move.l	72(a1),-$0A(a0)		; v_off_ad <- 8x8 offset table ad
	move.l	76(a1),-$16(a0)		; v_fnt_ad <- 8x8 font data addr 

	move.w  #008,-$2E(a0)		; v_cel_ht <- 8    8x8 cell height
	move.w  #0039,-$2A(a0)  	; v_cel_my <- 49    maximum cell "Y" 
*	use 8x8 font in 8x10 cell, giving 10*80 for v byte offset
	move.w  #800,-$28(a0)		; v_cel_wr <- 10*80 vertical byte offset
 
	move	#1,R0			; true return
	bra	ex40
ex40f:
	move	#0,R0			; false return
ex40:	unlk	R14			; prepare for return
	rts

*
*  Make hi rez screen bios handle 50 lines of 8x8 characters
*
		.globl _rez50

_rez50: 
	link	R14,#-4			; set up

	move.w	#GET_REZ,-(sp)		; get screen resolution
	trap	#14 
	addq.w	#2,sp
 
	cmp.w	#2,d0			; only execute if already in hi rez
	bne	ex50f 
 
	dc.w	LINEA_I			; get the important pointers 
 
	move.l	04(a1),a1		; a1 -> 8x8 font header 

	move.l	72(a1),-$0A(a0)		; v_off_ad <- 8x8 offset table ad
	move.l	76(a1),-$16(a0)		; v_fnt_ad <- 8x8 font data addr 

	move.w	#008,-$2E(a0)		; v_cel_ht <- 8  8x8 cell heigh
	move.w	#0049,-$2A(a0)		; v_cel_my <- 49  maximum cell "Y" 
	move.w	#640,-$28(a0)		; v_cel_wr <- 640  vertical byte offset
 
	move	#1,R0			; true return
	bra	ex50
ex50f:
	move	#0,R0			; false return
ex50:	unlk	R14			; prepare for return
	rts
	.data
	end 
